function nameFunction(name, body) {
    return (_a = {},
        _a[name] = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i - 0] = arguments[_i];
            }
            return body.apply(void 0, args);
        },
        _a
    )[name];
    var _a;
}
exports.asyncState = {
    isFetching: false,
    data: null,
    error: ''
};
exports.flowMiddleware = function (store) { return function (next) { return function (action) {
    if (!action.meta)
        return next(action);
    var matches = /^\w*\/(\w*)_(REQUEST|SUCCESS|FAILED)$/gm.exec(action.type);
    if (!matches)
        return next(action);
    var suffixedActionName = matches[0], actionName = matches[1], modifier = matches[2];
    if (modifier === 'REQUEST') {
        var asyncFunc = action.meta;
        var promise = action.payload
            ? asyncFunc(store.getState(), action.payload)
            : asyncFunc(store.getState().user);
        var dispatch = function (type, payload) {
            return store.dispatch({
                type: suffixedActionName.replace(modifier, type),
                payload: payload
            });
        };
        promise
            .then(function (res) { return dispatch('SUCCESS', res); })
            .catch(function (err) { return dispatch('FAILED', err.message); });
    }
    return next(action);
}; }; };
function default_1(name, _a) {
    var initialState = _a.initialState, mutations = _a.mutations, actions = _a.actions;
    var suffix = function (key) { return (name + "/" + key); };
    var actionCreators = [];
    var actionToReducer = {};
    var insertAction = function (actionType, name, meta) {
        actionCreators.push(nameFunction.apply(void 0, [name, function (payload) {
            var action = { type: actionType };
            if (!meta) {
                return payload ? {} : ;
            }
        }].concat(action, [payload])));
    }, action;
}
exports["default"] = default_1;
{
    return payload ? { action: action, payload: payload, meta: meta } : { action: action, meta: meta };
}
Object.entries(mutations).forEach(function (_a) {
    var mutationName = _a[0], mutation = _a[1];
    var actionType = suffix(mutationName);
    insertAction(actionType, mutationName);
    actionToReducer[actionType] = function (state, payload) {
        mutation(state, payload);
        return state;
    };
});
(_a = Object.entries(actions)).forEach.apply(_a, [function (_a) {
    var actionName = _a[0], _b = _a[1], selector = _b.selector, fn = _b.fn;
    var actionType = suffix(actionName);
    var req = actionType + "_REQUEST";
    insertAction(req, actionName, fn);
    var success = actionType + "_SUCCESS";
    var fail = actionType + "_FAILED";
    actionToReducer[req] = function (state) {
        return {};
    };
}].concat(state, [[selector], {}], state[selector], [isFetching, true, , actionToReducer[success] = function (state, payload) {
    return {};
}], state, [[selector], {
    isFetching: false,
    error: '',
    data: payload
}, actionToReducer[fail] = function (state, payload) {
    return {};
}], state, [[selector], {}], state[selector], [isFetching, false, error, payload, ]));
var reducer = function (state, action) {
    if (state === void 0) { state = initialState; }
    // Only reduce on our action types
    if (!actionToReducer[action.type])
        return state;
    return actionToReducer[action.type](state, action.payload);
};
var actionObj = {};
actionCreators.forEach(function (fn) {
    actionObj[fn.name] = fn;
});
return {
    reducer: reducer,
    actions: actionObj
};
var _a;
